//+------------------------------------------------------------------+
//|                                                VininI_Provit.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "vinin.ucoz.ru"
//    ,      
//        

#property indicator_separate_window
#property indicator_level1 0
#property indicator_buffers 3
#property indicator_color1 Yellow 
#property indicator_color2 Green
#property indicator_color3 Red

extern int Magic=1401;
extern double StopLoss=100;
extern double ProfitForJump=175;
extern double Trail=50;
//---- buffers
double Profit[];
double ProfitMax[];
double ProfitMin[];

bool first=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE,EMPTY,3);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(0,Profit);
   SetIndexBuffer(1,ProfitMax);
   SetIndexBuffer(2,ProfitMin);
   IndicatorShortName("Profit");
   SetIndexLabel(0,"Profit");
   SetIndexLabel(1,"Max Profit");
   SetIndexLabel(2,"Min Profit");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

   int i, total;
   double t=0;
   if(first==true)
   {
      for(i=200;i>=0;i--)
      {
         Profit[i]=0.0;
         ProfitMax[i]=0.0;
         ProfitMin[i]=-StopLoss;
      }
      first=false;
   }
   total=OrdersTotal();
   if(total>0)
   {
      for (i=0;i<total;i++)
      {
         if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
         {
            if (OrderMagicNumber()!=Magic) continue;
            t=t+OrderProfit();
         }
      }
      Profit[0]=t;
      ProfitMax[0]=MathMax(ProfitMax[1],t);
      if(ProfitMax[1]>ProfitForJump) ProfitMin[0]=ProfitMax[1]-Trail;
      else ProfitMin[0]=-StopLoss;
   }
   else
   {
      Profit[0]=0;
      ProfitMax[0]=0;
      ProfitMin[0]=-StopLoss;
   }
   return(0);
}
//+------------------------------------------------------------------+


